The C++ Template Image Processing Library. |

[Introduction]- [News]- [Download]- [Screenshots]- [Tutorial]- [Forums]- [Reference]- [SourceForge Repository ]

Main Page | Modules | Namespace List | Class Hierarchy | Class List | File List | Namespace Members | Class Members

# CImgl Struct Template Reference

This class represents list of images CImg<T>. More...

List of all members.

## Constructors - Destructor - Copy

| CImgl (const unsigned int n=0, const unsigned int width=0, const unsigned int height=1, const unsigned int depth=1, const unsigned int dim=1)
| Create a list of `n` new images, each having size (`width`,`height`,`depth`,`dim`).
| CImgl (const unsigned int n, const unsigned int width, const unsigned int height, const unsigned int depth, const unsigned int dim, const T &val)
| Create a list of `n` new images, each having size (`width`,`height`,`depth`,`dim`).
template<typename t>
| CImgl (const CImgl< t > &list)
| Copy constructor.
| CImgl (const char *filename)
| Create a list by loading a file.
| CImgl (const CImg< T > &img)
| Create a list from a single image `img`.
| CImgl (const CImg< T > &img1, const CImg< T > &img2)
| Create a list from two images `img1` and `img2` (images are copied).
| CImgl (const CImg< T > &img1, const CImg< T > &img2, const CImg< T > &img3)
| Create a list from three images `img1`,`img2` and `img3` (images are copied).
| CImgl (const CImg< T > &img1, const CImg< T > &img2, const CImg< T > &img3, const CImg< T > &img4)
| Create a list from four images `img1`,`img2`,`img3` and `img4` (images are copied).
template<typename t>
CImgl & | operator= (const CImgl< t > &list)
| Copy a list into another one.
| ~CImgl ()
| Destructor.
CImgl & | empty ()
| Empty list.
const char * | pixel_type ()
| Return a string describing the type of the image pixels in the list (template parameter `T`).

## Arithmetics operators

template<typename t>
CImgl & | operator+= (const CImgl< t > &list)
| Add each image of the current list with the corresponding image in the list `list`.
template<typename t>
CImgl & | operator-= (const CImgl< t > &list)
| Subtract each image of the current list with the corresponding image in the list `list`.
CImgl & | operator+= (const T &val)
| Add each image of the current list with a value `val`.
CImgl & | operator-= (const T &val)
| Substract each image of the current list with a value `val`.
CImgl & | operator *= (const double val)
| Multiply each image of the current list by a value `val`.
CImgl & | operator/= (const double val)
| Divide each image of the current list by a value `val`.
CImgl | operator+ (const T &val) const
| Return a new image list corresponding to the addition of each image of the current list with a value `val`.
CImgl | operator * (const double val) const
| Return a new image list corresponding to the multiplication of each image of the current list by a value `val`.
CImgl | operator- (const T &val) const
| Return a new image list corresponding to the substraction of each image of the current list with a value `val`.
CImgl | operator/ (const double val) const
| Return a new image list corresponding to the division of each image of the current list by a value `val`.
CImgl | operator+ (const CImgl &list) const
| Return a new image list corresponding to the addition of each image of the current list with the corresponding image in the list `list`.
CImgl | operator- (const CImgl &list) const
| Return a new image list corresponding to the substraction of each image of the current list with the corresponding image in the list `list`.
CImgl | operator+ (const T &val, const CImgl &list)
| Return a new image list corresponding to the addition of each image of the current list with a value `val`;.
CImgl | operator * (const double val, const CImgl &list)
| Return a new image list corresponding to the scalar multiplication of each image of the current list by a value `val`.

## List operations

CImg< T > & | operator[] (const unsigned int pos) const
| Return a reference to the i-th element of the image list.
CImg< T > & | operator() (const unsigned int pos) const
| Equivalent to CImgl<T>::operator[].
CImgl & | insert (const CImg< T > &img, const unsigned int pos)
| Insert a copy of the image `img` into the current image list, at position `pos`.
CImgl & | insert (const CImg< T > &img)
| Append a copy of the image `img` at the current image list.
CImgl & | insert (const CImgl< T > &list, const unsigned int pos)
| Insert a copy of the image list `list` into the current image list, starting from position `pos`.
CImgl & | insert (const CImgl< T > &list)
| Append a copy of the image list `list` at the current image list.
CImgl & | remove (const unsigned int pos)
| Remove the image at position `pos` from the image list.
CImgl & | remove ()
| Remove the last image from the image list.
CImgl & | reverse ()
| Reverse list order.
CImgl & | get_reverse ()
| Get reversed list.

## Fourier transforms

CImgl & | FFT (const char axe, const bool inverse=false)
| Compute the Fast Fourier Transform (along the specified axis).
CImgl & | FFT (const bool inverse=false)
| Compute the Fast Fourier Transform of a complex image.
CImgl | get_FFT (const bool inverse=false) const
| Return the Fast Fourier Transform of a complex image.
CImgl | get_FFT (const char axe, const bool inverse=false) const
| Return the Fast Fourier Transform of a complex image (along a specified axis).

## IO and display functions

const CImgl & | print (const char *title=NULL, const int print_flag=1) const
| Print informations about the list on the standart error stream.
const CImgl & | save (const char *filename) const
| Save an image list into a file.
const CImgl & | save_raw (const char *filename) const
| Save an image list into a RAW file.
CImg< T > | get_append (const char axe='x', const char align='c') const
| Return a single image which is the concatenation of all images of the current CImgl instance.
const CImgl & | display (CImgDisplay &disp, const char axe='x', const char align='c') const
| Display the current CImgl instance in an existing CImgDisplay window (by reference).
const CImgl & | display (CImgDisplay *disp, const char axe='x', const char align='c') const
| Display the current CImgl instance in an existing CImgDisplay window (by pointer).
const CImgl & | display (const char *title, const char axe='x', const char align='c', const int min_size=128, const int max_size=1024) const
| Display the current CImgl instance in a new display window.
const CImgl & | display (const char axe='x', const char align='c', const int min_size=128, const int max_size=1024) const
| Display the current CImgl instance in a new display window.
const CImgl & | wait (const unsigned int milliseconds) const
| Same as cimg::wait().
CImgl | load (const char *filename)
| Load an image list from a file. The file should be a '.raw' format, else only one image will be loaded into the list.
CImgl< T > | get_font7x11 (const bool fixed_size=false)
| Return a copy of the default 7x11 CImg font as a list of images and masks.

## Public Attributes

unsigned int | size
| This variable represents the number of images in the image list.
CImg< T > * | data
| Pointer to the first image of the image list.

## Detailed Description

### template<typename T>
struct cimg_library::CImgl< T >

This class represents list of images CImg<T>.

Definition at line 8858 of file CImg.h.

## Member Function Documentation

const CImgl& save | ( | const char * | filename | ) | const

| Save an image list into a file. Depending on the extension of the given filename, a file format is chosen for the output file. Definition at line 9348 of file CImg.h.

const CImgl& save_raw | ( | const char * | filename | ) | const

Save an image list into a RAW file.

A RAW file is a simple uncompressed binary file that may be used to save list of CImg<T> images.

Parameters:

  | filename | : name of the output file.

Returns:
  A reference to the current CImgl instance is returned.

Definition at line 9365 of file CImg.h.

CImg<T> get_append | ( | const char | axe = `'x'`,
|  | const char | align = `'c'`
| ) | const

Return a single image which is the concatenation of all images of the current CImgl instance.

Parameters:

  | axe | : specify the axe for image concatenation. Can be 'x','y','z' or 'v'.
  | align | : specify the alignment for image concatenation. Can be 'p' (top), 'c' (center) or 'n' (bottom).

Returns:
  A CImg<T> image corresponding to the concatenation is returned.

Definition at line 9388 of file CImg.h.

CImgl<T> get_font7x11 | ( | const bool | fixed_size = `false` | ) | `[static]`

Return a copy of the default 7x11 CImg font as a list of images and masks.

Parameters:

  | fixed_size | = compute fixed or variable character size

Definition at line 9497 of file CImg.h.

const CImgl& display | ( | CImgDisplay & | disp,
|  | const char | axe = `'x'`,
|  | const char | align = `'c'`
| ) | const

Display the current CImgl instance in an existing CImgDisplay window (by reference).

This function displays the list images of the current CImgl instance into an existing CImgDisplay window. Images of the list are concatenated in a single temporarly image for visualization purposes. The function returns immediately.

Parameters:

  | disp | : reference to an existing CImgDisplay instance, where the current image list will be displayed.
  | axe | : specify the axe for image concatenation. Can be 'x','y','z' or 'v'.
  | align | : specify the alignment for image concatenation. Can be 'p' (top), 'c' (center) or 'n' (bottom).

Returns:
  A reference to the current CImgl instance is returned.

Definition at line 9518 of file CImg.h.

const CImgl& display | ( | CImgDisplay * | disp,
|  | const char | axe = `'x'`,
|  | const char | align = `'c'`
| ) | const

Display the current CImgl instance in an existing CImgDisplay window (by pointer).

This function displays the list images of the current CImgl instance into an existing CImgDisplay window. Images of the list are concatenated in a single temporarly image for visualization purposes. The function returns immediately.

Parameters:

  | disp | : pointer to an existing CImgDisplay instance, where the current image list will be displayed.
  | axe | : specify the axe for image concatenation. Can be 'x','y','z' or 'v'.
  | align | : specify the alignment for image concatenation. Can be 'p' (top), 'c' (center) or 'n' (bottom).

Returns:
  A reference to the current CImgl instance is returned.

Definition at line 9532 of file CImg.h.

const CImgl& display | ( | const char * | title,
|  | const char | axe = `'x'`,
|  | const char | align = `'c'`,
|  | const int | min_size = `128`,
|  | const int | max_size = `1024`
| ) | const

Display the current CImgl instance in a new display window.

This function opens a new window with a specific title and displays the list images of the current CImgl instance into it. Images of the list are concatenated in a single temporarly image for visualization purposes. The function returns when a key is pressed or the display window is closed by the user.

Parameters:

  | title | : specify the title of the opening display window.
  | axe | : specify the axe for image concatenation. Can be 'x','y','z' or 'v'.
  | align | : specify the alignment for image concatenation. Can be 'p' (top), 'c' (center) or 'n' (bottom).
  | min_size | : specify the minimum size of the opening display window. Images having dimensions below this size will be upscaled.
  | max_size | : specify the maximum size of the opening display window. Images having dimensions above this size will be downscaled.

Returns:
  A reference to the current CImgl instance is returned.

Definition at line 9552 of file CImg.h.

const CImgl& display | ( | const char | axe = `'x'`,
|  | const char | align = `'c'`,
|  | const int | min_size = `128`,
|  | const int | max_size = `1024`
| ) | const

Display the current CImgl instance in a new display window.

This function opens a new window and displays the list images of the current CImgl instance into it. Images of the list are concatenated in a single temporarly image for visualization purposes. The function returns when a key is pressed or the display window is closed by the user.

Parameters:

  | axe | : specify the axe for image concatenation. Can be 'x','y','z' or 'v'.
  | align | : specify the alignment for image concatenation. Can be 'p' (top), 'c' (center) or 'n' (bottom).
  | min_size | : specify the minimum size of the opening display window. Images having dimensions below this size will be upscaled.
  | max_size | : specify the maximum size of the opening display window. Images having dimensions above this size will be downscaled.

Returns:
  A reference to the current CImgl instance is returned.

Definition at line 9571 of file CImg.h.

const CImgl& wait | ( | const unsigned int | milliseconds | ) | const

Same as cimg::wait().

See also:
  cimg::wait().

Definition at line 9580 of file CImg.h.

## Member Data Documentation

unsigned int size

This variable represents the number of images in the image list.

Note:
  if `size==0`, the image list is empty.

Definition at line 8863 of file CImg.h.

CImg<T>* data

Pointer to the first image of the image list.

Note:
  the images are stored continuously in memory.

  If the list is empty, `data=NULL`.

Definition at line 8870 of file CImg.h.